// Hint: This file is just for external use (eg. WYSIWYG CSS)
//       It's not used in the frontend.
// TODO: VL copy current state to https://gitlab.com/webksde/drupal/webksdct-admin and install it via npm
// TODO!! Make layout_builder.scss & entity_reference_layout.scss seperate gitlab probjects (maybe public?)
//        See if we have more candidates (scss) to do this.. mixins ==> https://gitlab.com/webksde/drupal/webksdct-base/issues
// TODO: Replace all SASS (color) variables with css variables, we dont want customer specific ui colors.

// Copied variables from admin-variables.css (drowl_admin module) to have vscode autocompletion, what even works if commented out - but not simply across files -_-
// :root{
//   /* Brand variables */
//   --drowl-green: #89a129;
//   --drowl-text-color: #342e37;
//   --drowl-green-text-color: #fff;
//   --drowl-border-radius-small: 3px;
//   /* Adminimal Theme colors */
//   --adminimal-primary: #327ebd;
//   --adminimal-primary-light: #8abbe4;
//   --adminimal-grey-light: #dbdbdb;
//   /* Spaces */
//   --drowl-space-md: 1rem;
//   /* Typo */
//   --drowl-font-family: "Open Sans", Arial, sans-serif; /* Font family used by admin toolbar, what should be available everywhere we need it too. */
//   --drowl-font-size-base: 16px;
//   --drowl-font-size-small: 14px;
//   --drowl-font-weight-bold: 600;
//   /* Colors */
//   --drowl-gray-light: #eeeeee;
//   --drowl-gray-medium: #cccccc;
//   --drowl-white-glass: rgba(255,255,255,.65);
//   --drowl-black-glass: rgba(0,0,0,.75);
//   /* Status colors (https://coolors.co/3c91e6-342e37-e5ece6-a2d729-fa824c) */
//   --drowl-success: #a2d729;
//   --drowl-success-light: #eef7d8;
//   --drowl-success-text: #fff;
//   --drowl-warning: #fd6d2a;
//   --drowl-warning-light: #fee8de;
//   --drowl-warning-text: #fff;
//   --drowl-info: #3c91e6;
//   --drowl-info-light: #dbebfa;
//   --drowl-info-transparent: rgba(60,145,230,.5);
//   --drowl-info-text: #fff;
//   /* Objects */
//   /* -- Buttons */
//   --drowl-button-border-radius: var(--drowl-border-radius-small);
//   --drowl-button-padding: 8px 15px;
//   --drowl-button-default-background: var(--drowl-info);
//   --drowl-button-default-color: var(--drowl-info-text);
//   --drowl-button-text-shadow: 1px 1px 1px rgba(0,0,0,.25);
//   /* Editors */
//   --drowl-editor-border-radius-small: var(--drowl-border-radius-small);
//   --drowl-editor-grid-gutter: 8px;
// }

@import './scss/_configuration/settings';

// Custom mixins
@import './scss/_mixins/mixins';

// TODO: Add the generated css file to the module and replace it by library override in theme

// Admin UI
#page{ // use id selector instead of !important to ensure the styles will override default theme styles
  .layout-builder{
    --layout-builder-outer-grid-space: 20px;
    font-family: var(--drowl-font-family);
    padding: var(--layout-builder-outer-grid-space);
    &__link{
      // Buttons (all)
      display:inline-block;
      background-color: var(--drowl-button-default-background);
      color: var(--drowl-button-default-color);
      padding: var(--drowl-button-padding);
      border:0 none;
      border-radius: var(--drowl-button-border-radius);
      font-size: var(--drowl-font-size-small);
      font-family: var(--drowl-font-family);
      text-shadow: var(--drowl-button-text-shadow);
      text-decoration:none;
      background-image:none; // remove the ugly core svg icons
      white-space:nowrap;
      overflow:hidden;
      text-overflow: ellipsis;
      line-height:20px;
      vertical-align: middle;
      margin-bottom:1rem;
      &:last-child{
        margin-bottom:0;
      }
      &::before{
        float:left;
        display:block;
        font-weight: var(--drowl-font-weight-bold);
        font-size:20px;
        text-align:center;
        width:20px;
        height:20px;
        line-height:20px;
        border-radius:50%;
        margin-right:8px;
        background-color: var(--drowl-success-text);
        color: var(--drowl-text-color);
        box-shadow: 0 0 3px rgba(0,0,0,.1);
        text-shadow: none;
      }
      &:hover{
        filter: brightness(103%);
      }
      &:active{
        filter: brightness(95%);
      }
      &--add{
        background-color: var(--drowl-success);
        border-color: var(--drowl-success);
        color: var(--drowl-success-text);
        &::before{
          content: "+";
          color: var(--drowl-success);
        }
      }
      &--remove{
        background-color: var(--drowl-warning);
        border-color: var(--drowl-warning);
        color: var(--drowl-warning-text);
        // Undo some core styles
        text-indent:0;
        height:auto;
        width:auto;
        &::before{
          content: "+";
          transform: rotate(-45deg);
          color: var(--drowl-warning);
        }
      }
    }
    &__section{
      --section-border-color: var(--drowl-gray-medium);
      position:relative;
      margin-left: calc(var(--layout-builder-outer-grid-space) * -1);
      margin-right: calc(var(--layout-builder-outer-grid-space) * -1);
      padding: 15px var(--layout-builder-outer-grid-space);
      border-width:2px 0;
      border-style:solid none;
      border-color: var(--section-border-color);
      // Add arrows so the user is able to see the beginning and the end of a section
      &::before,
      &::after{
        content:"";
        position:absolute;
        top:-1px;
        left:50%;
        margin-left:-3px;
        border-width:6px;
        border-style:solid;
        border-color: var(--section-border-color) transparent transparent transparent;
      }
      &::after{
        top:auto;
        bottom:-1px;
        border-color: transparent transparent var(--section-border-color) transparent;
      }
      &:hover{
        --section-border-color: var(--adminimal-primary)
      }
      // Section buttons
      > .layout-bulder__link{
        margin: 0 var(--drowl-space-md) var(--drowl-space-md) 0;
      }
      // Drag and drop
      .ui-state-drop {
        background: var(--drowl-warning-light) !important;
        outline-color: var(--drowl-warning) !important;
        flex-grow: 1;
        z-index:99999;
      }
      .layout-builder-block{
        &.ui-sortable-helper{
          // while dragging
          opacity:.75;
          box-shadow: 1px 1px 8px rgba(0,0,0,.35);
        }
      }
    }
    &__layout{
      >.layout-builder__region {
        margin-bottom: 20px; // prevent colliding outlines
        // Fix collapsing margins
        padding-top:1px;
        padding-bottom:1px;
      }
    }
    &__region{
      outline-color: var(--drowl-info);
      background: white;
      min-height:10px;
      position:relative;
      &:hover{
        outline-style: solid;
      }
      &.viewport-width{
        // Prevent the region from being cutted off (because of the 100vw width + scrollbar problem)
        width: 98vw;
        transform: translateX(1vw);
      }
    }
    &__region-label {
      display: block;
      font-style: italic;
      position: absolute;
      left: -2px;
      top: -2px;
      z-index:2;
      background: var(--drowl-info);
      color: var(--drowl-info-text);
      padding: .5em;
      border:0 none;
      border-radius: 0 0 5px 0;
      user-select: none;
      border: 0 none;
      font-size: var(--drowl-font-size-small);
      white-space:nowrap;
      overflow:hidden;
      text-overflow:ellipsis;
      max-width:100px;
      &:hover{
        max-width:100%;
      }
    }
    &__add-section{
      background-color: transparent;
      outline-color: var(--drowl-gray-light);
      padding: var(--drowl-space-md);
      margin-bottom: var(--drowl-space-md);
      &:hover{
        outline-style: solid;
        outline-color: var(--drowl-gray-medium);
      }
    }
    &__add-block{
      display:flex;
      justify-content: center;
      transition-duration:150ms;
      transition-property: max-height, padding;
      transition-delay: 250ms; // prevent starting the animation if the user just moves the cursor around
      padding:8px;
      overflow:hidden;
    }
    // Current active add section / block modifier
    .is-layout-builder-highlighted{
      outline: 2px solid var(--drowl-success);
      background-color: var(--drowl-success-light);
      border: 0 none;
    }
    // Content preview mode
    &--content-preview-disabled{
      .layout-builder-block{
        // Remove "placeholder for x" text (no wrapper)
        min-height:2rem;
        padding:1rem;
        display:flex;
        flex-direction: column;
        justify-content: center;
        font-size:0;
        color: transparent;
        border: 0 none;
        &__content-preview-placeholder-label{
          color: var(--drowl-text-color);
          font-size: 1rem;
          font-weight: var(--drowl-font-weight-bold);
          &::before{
            // TODO: Add kinda.. drag icon grippie.. thing
            // content: $ico-more;
            // line-height:1;
            // font-family: $iconfont-family;
            // margin-right:.5em;
          }
        }
        &:nth-child(2n+1){
          background-color: var(--drowl-info-light);
        }
        &:hover{
          background-color: var(--drowl-success-light);
        }
        &:first-of-type{
          padding-top:2rem; // reserved space for the region label
        }
      }
    }
    &:not(.layout-builder--content-preview-disabled) {
      // Reduce ui implications if content preview is enabled
      .layout-builder__region-label{
        display:none;
      }
      .layout-builder__region{
        outline-color: var(--drowl-info-transparent);
        &:hover{
          > .layout-builder__add-block {
            max-height:150px;
            padding:6px;
          }
        }
      }
      .layout-builder__add-block{
        max-height:0;
        padding:0;
      }
    }
    // Fix content preview
    .layout-builder-block{
      // Force linebreaks for overlong strings
      word-break: break-word;
    }
    // -- Card tiles
    .card.card--tile{
      .card__image{
        position:static;
        transform: scale(1) !important;
        *{
          height:auto;
        }
      }
    }
  }
  .grid-x{
    margin-bottom: var(--drowl-space-md);
  }
}
// Other form elements
#node-page-layout-builder-form {
  >.form-item{
    @include xy-grid-container;
  }
}
// More compact layout selection
#drupal-off-canvas{
  .layout-selection{
    display:grid;
    grid-template-columns: 1fr 1fr 1fr;
    grid-template-rows: auto;
    grid-column-gap: 20px;
    grid-row-gap: 20px;
    > li{
      min-width:0;
      > a{
        text-align: center;
        > div{
          white-space:nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
        }
      }
      &:hover{
        .layout-icon{
          rect{
            fill: var(--drowl-info);
            stroke: var(--drowl-info);
          }
        }
      }
    }
  }
}
// Docked edit actions
#entity-view-display-layout-builder-form > #edit-actions,
form[id*="layout-builder-form"] > #edit-actions{
  position:fixed;
  bottom:0;
  left:0;
  z-index:100;
  width:100%;
  background: var(--drowl-black-glass);
  color: var(--drowl-gray-light);
  padding:10px;
  display:flex;
  align-items:center;
  justify-content: center;
  .form-item{
    margin-bottom:0;
    margin-left:.75rem;
    margin-right:.75rem;
    label.option::before{
      margin-right:.45rem;
      color: var(--drowl-success);
    }
  }
  .button{
    margin-bottom:0;
    margin-left:3px;
    margin-right:3px;
    &#edit-submit{
      background-color: var(--drowl-success);
      border-color: var(--drowl-success);
      color: var(--drowl-success-text);
      text-shadow: var(--drowl-button-text-shadow);
    }
    &#edit-discard-changes,
    &#edit-revert{
      &:hover{
        background-color: var(--drowl-warning);
        border-color: var(--drowl-warning);
        color: var(--drowl-warning-text);
        text-shadow: var(--drowl-button-text-shadow);
      }
    }
  }
  // Toggle preview checkbox
  #edit-preview-toggle{
    margin-left:2rem;
  }
  .form-item-toggle-content-preview input[type="checkbox"]{
    & +label::before{
      content: $ico-eye-blocked;
      background-color: transparent;
      border:0 none;
      color: var(--drowl-warning);
      font-size:18px;
      line-height:1; // TODO: fix this in the regular styled checkboxes definition
      margin-top:2px;
      box-shadow:none !important; // TODO: There is an inset shadow set on hover by _forms-scss
      display:flex;
      align-items:center;
      justify-content: center;
    }
    &:checked+label::before {
      content: $ico-eye;
      background-color: transparent;
      border-color: var(--drowl-success);
      color: var(--drowl-success);
    }
  }
}

// Also fix vertical tabs beyond
.js-form-type-vertical-tabs{
  @include xy-grid-container();
  .vertical-tabs__panes{
    padding:10px;
  }
}
